
#ifndef _ABILITY_H
#define _ABILITY_H

#include <gnome.h>

#define GM_STONE_NO_EFFECT (0)
#define GM_STONE_WEAK (GM_FLYING | GM_STONE)
#define GM_STONE_STRONG (GM_ELECTRIC | GM_FIRE)
#define GM_FLYING_NO_EFFECT (0)
#define GM_FLYING_WEAK (GM_STONE | GM_FIRE)
#define GM_FLYING_STRONG (GM_INSECT | GM_PLANT | GM_FUNGUS)
#define GM_ELECTRIC_NO_EFFECT (0)
#define GM_ELECTRIC_WEAK (GM_PLANT | GM_FUNGUS | GM_ELECTRIC | GM_ENERGY)
#define GM_ELECTRIC_STRONG (GM_WATER | GM_CYBERNETIC | GM_FLYING | GM_NOCTURNAL | GM_ICE)
#define GM_WATER_NO_EFFECT (GM_ICE)
#define GM_WATER_WEAK (GM_PLANT | GM_FUNGUS | GM_ELECTRIC | GM_WATER)
#define GM_WATER_STRONG (GM_STONE | GM_CYBERNETIC | GM_FIRE)
#define GM_FIRE_NO_EFFECT (0)
#define GM_FIRE_WEAK (GM_STONE | GM_WATER)
#define GM_FIRE_STRONG (GM_PLANT | GM_FUNGUS | GM_NOCTURNAL | GM_ICE)
#define GM_POISON_NO_EFFECT (GM_CYBERNETIC)
#define GM_POISON_WEAK (GM_POISON | GM_STONE)
#define GM_POISON_STRONG (0)
#define GM_INSECT_NO_EFFECT (0)
#define GM_INSECT_WEAK (GM_INSECT)
#define GM_INSECT_STRONG (GM_PLANT | GM_FUNGUS)
#define GM_PLANT_NO_EFFECT (0)
#define GM_PLANT_WEAK (GM_STONE | GM_PLANT | GM_INSECT)
#define GM_PLANT_STRONG (GM_FUNGUS | GM_WATER)
#define GM_FIGHTING_NO_EFFECT (0)
#define GM_FIGHTING_WEAK (GM_PLANT | GM_FUNGUS)
#define GM_FIGHTING_STRONG (GM_STONE | GM_CYBERNETIC | GM_ICE)
#define GM_PSYCHIC_NO_EFFECT (GM_CYBERNETIC | GM_PLANT)
#define GM_PSYCHIC_WEAK (GM_PSYCHIC | GM_FUNGUS | GM_INSECT | GM_GHOST)
#define GM_PSYCHIC_STRONG (GM_FIGHTING)
#define GM_FUNGUS_NO_EFFECT (0)
#define GM_FUNGUS_WEAK (GM_STONE | GM_WATER | GM_FUNGUS)
#define GM_FUNGUS_STRONG (GM_CYBERNETIC | GM_FLYING)
#define GM_NOCTURNAL_NO_EFFECT (0)
#define GM_NOCTURNAL_WEAK (GM_FIRE)
#define GM_NOCTURNAL_STRONG (GM_INSECT)
#define GM_CYBERNETIC_NO_EFFECT (0)
#define GM_CYBERNETIC_WEAK (GM_WATER | GM_ENERGY)
#define GM_CYBERNETIC_STRONG (GM_STONE)
#define GM_ICE_NO_EFFECT (0)
#define GM_ICE_WEAK (GM_ELECTRIC | GM_ICE)
#define GM_ICE_STRONG (GM_PLANT | GM_FIRE | GM_WATER)
#define GM_ENERGY_NO_EFFECT (GM_ENERGY)
#define GM_ENERGY_WEAK (GM_ELECTRIC)
#define GM_ENERGY_STRONG (GM_CYBERNETIC)
#define GM_GHOST_NO_EFFECT (GM_GHOST | GM_PSYCHIC)
#define GM_GHOST_WEAK (GM_FIRE | GM_ELECTRIC | GM_ENERGY)
#define GM_GHOST_STRONG (GM_FIGHTING | GM_PLANT | GM_INSECT | GM_CYBERNETIC | GM_STONE | GM_FLYING)

typedef enum
{
	GM_STONE = 1,
	GM_FLYING = 2,
	GM_ELECTRIC = 4,
	GM_WATER = 8,
	GM_FIRE = 16,
	GM_POISON = 32,
	GM_INSECT = 64,
	GM_PLANT = 128,
	GM_FIGHTING = 256,
	GM_PSYCHIC = 512,
	GM_FUNGUS = 1024,
	GM_NOCTURNAL = 2048,
	GM_CYBERNETIC = 4096,
	GM_ICE = 8192,
	GM_ENERGY = 16384,
	GM_GHOST = 32768
}
GMClassification;

typedef enum
{
	GM_PHYSICAL,
	GM_MENTAL
}
GMDamageType;

typedef enum
{
	GM_MEDIUM,
	GM_SUPER,
	GM_WEAK,
	GM_NO_EFFECT
}
GMEffective;

typedef enum
{
	GM_LEFT,
	GM_RIGHT
}
GMBattleSide;

typedef struct _GMAbility GMAbility;

typedef struct _GMEffectFunc
{
	gboolean possible;
	void (*func) (GMAbility *, gpointer, gpointer);
}
GMEffectFunc;

struct _GMAbility
{
	GMClassification type;
	gchar *name;
	void (*animfunc) (GtkWidget *, GnomeCanvasItem *, GnomeCanvasItem *,
					  GMBattleSide);
	GMDamageType dmgtype;
	guint damage, chance, cost;
	gint recovery;
	gboolean no_effect;
	guint noe;
	GMEffectFunc effects[5];
};

gchar *gm_class_name (GMClassification);
GMEffective gm_class_effective (GMClassification, GMClassification);
GMAbility *gm_ability_get_list ();
guint gm_ability_list_length ();
GMAbility *gm_ability_match (gchar *);
void gm_ability_call (gchar *, gpointer, gpointer);

#endif
