
#ifndef _BATTLE_H
#define _BATTLE_H

#include <gmonsters/gm-battle-window.h>
#include <gmonsters/trainer.h>

#define GM_PIC_X(a) (a == GM_LEFT ? (double)100 : (double)300)
#define GM_PIC_Y (double)150
#define GM_PIC_WIDTH (double)150
#define GM_PIC_HEIGHT (double)150

typedef enum
{
	GM_SINGLE_PLAYER,
	GM_MULTIPLAYER_HOST,
	GM_MULTIPLAYER_CLIENT
}
GMBattleType;

typedef enum
{
	GM_NOT_DONE,
	GM_WON,
	GM_LOST,
	GM_CAPTURE,
	GM_WITHDRAWN,
	GM_ENEMY_WITHDREW
}
GMOutcome;

typedef enum
{
	GM_EOT_NONE,
	GM_ABSORB_AS_HP,
	GM_ABSORB_AS_STR,
	GM_COUNTER_ATTACK
}
GMEOTEffects;

typedef enum
{
	GM_NORMAL,
	GM_STUN,
	GM_SLEEP,
	GM_CONFUSED,
	GM_FAINTED
}
GMStatus;

typedef struct _GMBattleEffects
{
	GMTrainer *trainer;
	GMMonster *monster;
	GMStatus status;
	gint str, def, spd, wis;
	guint fear, acc, wait;
	gboolean poisoned, leech;
	GMEOTEffects eot;
	GnomeCanvasItem *pic;
	GMBattleSide side;
	GtkWidget *window;
}
GMBattleEffects;

GMOutcome gm_battle_start (GMTrainer *,
						   guint (*)(GMBattleEffects *, gboolean),
						   GMTrainer *, guint (*)(GMBattleEffects *,
												  gboolean), gboolean,
						   GMBattleType, gboolean);
guint gm_battle_player_cb (GMBattleEffects *, gboolean);
guint gm_battle_ai_cb (GMBattleEffects *, gboolean);
guint gm_battle_net_cb (GMBattleEffects *, gboolean);
guint gm_battle_effects_deal_damage (GMBattleEffects *, GMClassification,
									 guint, GMDamageType);

#endif
