
#ifndef _ITEM_H
#define _ITEM_H

#include <gnome.h>
#include <gmonsters/ability.h>

typedef enum
{
	GM_ITEM_NORMAL,
	GM_ITEM_BATTLE,
	GM_ITEM_ANY
}
GMItemType;

typedef struct _GMItemFunc
{
	gboolean (*func) (GMItemType, gpointer, gpointer, GtkWidget *);
	gpointer param;
}
GMItemFunc;

typedef struct _GMItem
{
	GMItemType type;
	gchar *name;
	guint noe;
	GMItemFunc effects[5];
}
GMItem;

typedef struct _GMItemList
{
	guint num;
	gchar *name;
}
GMItemList;

GMItem *gm_item_get_list ();
guint gm_item_list_length ();
GMItem *gm_item_match (gchar *);
gboolean gm_item_normal_use (gchar *, gpointer);
gboolean gm_item_battle_use (gchar *, gpointer, GtkWidget *);

#endif
