
#ifndef _MONSTERS_H
#define _MONSTERS_H

#include <gmonsters/species.h>

typedef enum
{
	GM_MALE,
	GM_FEMALE
}
GMGender;

typedef struct _GMMonAbl
{
	gchar *name;
	gboolean active;
}
GMMonAbl;

typedef struct _GMMonster
{
	GMSpecies *spec;
	gchar *name, *tamer;
	guint lvl, hp, exp, nxp, ap, noa, maxhp, str, def, spd, wis, obe;
	GMGender gen;
	GMMonAbl **abilities;
	gulong id;
}
GMMonster;

typedef struct _GMMonsterList
{
	gboolean active;
	gchar *name;
	gulong id;
}
GMMonsterList;

GMMonster *gm_monster_new (GMSpecies *, gchar *, GMGender, guint);
GMMonster *gm_monster_open (gulong);
GMMonster *gm_monster_open_net (gulong);
void gm_monster_send_net (gulong);
void gm_monster_close (gulong);
void gm_monster_destroy (gulong);
void gm_monster_learn_ability (GMMonster *, gchar *, gboolean);
void gm_monster_give_exp (GMMonster *, guint, gboolean);
guint gm_monster_maxhp (GMMonster *, gint);
guint gm_monster_str (GMMonster *, gint);
guint gm_monster_def (GMMonster *, gint);
guint gm_monster_spd (GMMonster *, gint);
guint gm_monster_int (GMMonster *, gint);

#endif
