
#ifndef _SPECIES_H
#define _SPECIES_H

#include <gmonsters/ability.h>

typedef enum
{
	GM_PLAINS = 1,
	GM_FOREST = 2,
	GM_CAVES = 4,
	GM_MOUNTAINS = 8,
	GM_OCEANS = 16,
	GM_RIVERS = 32
}
GMAreas;

typedef struct _GMLearnAbility
{
	gchar *ability;
	guint level;
}
GMLearnAbility;

typedef struct _GMSpecies
{
	GdkImlibImage *image;
	gchar *name, *desc;
	GMClassification type;
	guint shp, sstr, sdef, sspd, swis, alistlen;
	GMLearnAbility **alist;
	GMAreas areas;
}
GMSpecies;

void gm_species_load (GtkProgressBar *);
GMSpecies *gm_species_get_list ();
guint gm_species_list_length ();
GMSpecies *gm_species_match (gchar *);

#endif
