
#ifndef _TRAINER_H
#define _TRAINER_H

#include <gmonsters/ability.h>
#include <gmonsters/species.h>
#include <gmonsters/monsters.h>
#include <gmonsters/item.h>

typedef struct _GMSkillLevel
{
	guint normal, stone, flying, electric, water, fire, poison, insect;
	guint plant, fighting, psychic, fungus, nocturnal, cybernetic, ice;
	guint energy, ghost;
}
GMSkillLevel;

typedef struct _GMTrainer GMTrainer;

struct _GMTrainer
{
	gchar *name;
	guint money, nom, noi;
	GMMonsterList **monsters;
	GMItemList **items;
	GMSkillLevel skill;
	GMMonster *(*monselect) (GMTrainer *);
	GMItemList *(*itemselect) (GMTrainer *);
};

GMTrainer *gm_trainer_new ();
GMTrainer *gm_trainer_load (FILE *);
GMTrainer *gm_trainer_load_net ();
void gm_trainer_save (FILE *, GMTrainer *);
void gm_trainer_send_net (GMTrainer *);
guint gm_trainer_skill (GMTrainer *, GMClassification);
void gm_trainer_raise_skill (GMTrainer *, GMClassification);
void gm_trainer_lower_skill (GMTrainer *, GMClassification);
void gm_trainer_add_monster (GMTrainer *, GMMonster *);
void gm_trainer_remove_monster (GMTrainer *, gulong);
void gm_trainer_delete_monster (GMTrainer *, gulong);
void gm_trainer_deactivate (GMTrainer *, gulong);
GMMonster *gm_trainer_select_monster (GMTrainer *);
GMMonster *gm_trainer_player_select (GMTrainer *);
GMMonster *gm_trainer_ai_select (GMTrainer *);
void gm_trainer_add_item (GMTrainer *, GMItem *, guint);
gboolean gm_trainer_remove_item (GMTrainer *, gchar *, guint);
GMItemList *gm_trainer_select_item (GMTrainer *);
GMItemList *gm_trainer_item_player_select (GMTrainer *);
GMItemList *gm_trainer_item_ai_select (GMTrainer *);
GMMonster *gm_trainer_net_select (GMTrainer *);
GMItemList *gm_trainer_item_net_select (GMTrainer *);

#endif
